Attribute VB_Name = "MSharedTimer"
' *********************************************************************
'  Copyright 1998 Karl E. Peterson, All Rights Reserved
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private m_Cntls As Collection
Private m_TmrID As Long
Private m_Count As Long

Private Const tmrDelay = 500

Public Sub RegisterInstance(obj As ISharedTimer)
   '
   ' Make sure collection is initialized.
   '
   If m_Cntls Is Nothing Then
      Set m_Cntls = New Collection
   End If
   '
   ' Add control pointer to collection.
   '
   m_Cntls.Add ObjPtr(obj), Hex(ObjPtr(obj))
   m_Count = m_Count + 1
   '
   ' If this is the first registered control,
   ' and we're not in the IDE, start the timer.
   '
   If m_Cntls.Count = 1 Then
      If obj.AmbientUserMode Then
         '
         ' Set new timer using values set in module constants.
         '
         m_TmrID = SetTimer(0&, 0&, tmrDelay, AddressOf TimerProc)
      End If
   End If
End Sub

Public Sub UnRegisterInstance(obj As ISharedTimer)
   '
   ' Remove control pointer from collection.
   '
   On Error Resume Next
      m_Cntls.Remove Hex(ObjPtr(obj))
      m_Count = m_Count - 1
   On Error GoTo 0
   '
   ' Kill timer if this is the last control.
   '
   If m_Cntls.Count = 0 Then
      If m_TmrID Then
         Call KillTimer(0&, m_TmrID)
         m_TmrID = 0
      End If
   End If
End Sub

Public Function InstanceCount() As Long
   '
   ' Expose count of control instances.
   '
   InstanceCount = m_Count
End Function

Private Sub TimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
   Dim Cntl As ISharedTimer
   Dim lpObj As Variant
   Static ShowColons As Boolean
   '
   ' Toggle global colon visibility.
   '
   ShowColons = Not ShowColons
   '
   ' Loop through control pointer collection,
   ' firing Timer method in each instance.
   '
   For Each lpObj In m_Cntls
      CopyMem Cntl, CLng(lpObj), 4
      Cntl.Timer ShowColons
   Next lpObj
   CopyMem Cntl, 0&, 4
End Sub

